"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNamespace = void 0;
const Exception_1 = require("../../Exception");
const Guard = __importStar(require("../Guard"));
const Name = __importStar(require("../Name"));
const Reference = __importStar(require("./Reference"));
const SecuritySchema = __importStar(require("./SecuritySchema"));
const generateNamespace = (entryPoint, currentPoint, store, factory, requestBodies) => {
    store.addComponent("securitySchemes", {
        kind: "namespace",
        name: Name.Components.SecuritySchemas,
    });
    Object.entries(requestBodies).forEach(([name, requestBody]) => {
        if (Guard.isReference(requestBody)) {
            const reference = Reference.generate(entryPoint, currentPoint, requestBody);
            if (reference.type === "local") {
                if (!store.hasStatement(reference.path, ["interface"])) {
                    throw new Exception_1.UndefinedComponent(`Reference "${requestBody.$ref}" did not found in ${reference.path} by ${reference.name}`);
                }
                return;
            }
            const path = `components/securitySchemes/${reference.name}`;
            return store.addStatement(path, {
                kind: "interface",
                name,
                value: SecuritySchema.generateInterface(entryPoint, reference.referencePoint, factory, name, reference.data),
            });
        }
        const path = `components/securitySchemes/${name}`;
        return store.addStatement(path, {
            kind: "interface",
            name: name,
            value: SecuritySchema.generateInterface(entryPoint, currentPoint, factory, name, requestBody),
        });
    });
};
exports.generateNamespace = generateNamespace;
//# sourceMappingURL=SecuritySchemas.js.map