import ts from "typescript";
import { escapeIdentiferText, generateComment } from "./utils";
export const create = ({ factory }) => (params) => {
    const node = factory.createInterfaceDeclaration(undefined, params.export && [factory.createModifier(ts.SyntaxKind.ExportKeyword)], factory.createIdentifier(escapeIdentiferText(params.name)), params.typeParameters, undefined, params.members);
    if (params.comment) {
        const comment = generateComment(params.comment, params.deprecated);
        return ts.addSyntheticLeadingComment(node, ts.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
    }
    return node;
};
export const make = (context) => {
    return {
        create: create(context),
    };
};
//# sourceMappingURL=InterfaceDeclaration.js.map