import ts from "typescript";
import type { OpenApi } from "../../../types";
import { Factory } from "../../TsGenerator";
import * as ConverterContext from "../ConverterContext";
import * as ToTypeNode from "../toTypeNode";
import * as Reference from "./Reference";
export declare const generateTypeNode: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, header: OpenApi.Header, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.TypeAliasDeclaration;
export declare const generatePropertySignature: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, header: OpenApi.Header | OpenApi.Reference, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.PropertySignature;
export declare const generatePropertySignatures: (entryPoint: string, currentPoint: string, factory: Factory.Type, headers: Record<string, OpenApi.Header | OpenApi.Reference>, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.PropertySignature[];
export declare const generateInterface: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, headers: Record<string, OpenApi.Header | OpenApi.Reference>, context: ToTypeNode.Context, converterContext: ConverterContext.Types) => ts.InterfaceDeclaration;
